/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"fmt"
)

// ReceiverType 0 - native messenger id, 1 - communication channel id, 2 - conversation id
type ReceiverType int32

// List of ReceiverType
const (
	RECEIVER_NATIVE_MESSENGER_ID ReceiverType = 0
	RECEIVER_COMMUNICATION_CHANNEL ReceiverType = 1
	RECEIVER_CONVERSATION ReceiverType = 2
)

// All allowed values of ReceiverType enum
var AllowedReceiverTypeEnumValues = []ReceiverType{
	0,
	1,
	2,
}

func (v *ReceiverType) UnmarshalJSON(src []byte) error {
	var value int32
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := ReceiverType(value)
	for _, existing := range AllowedReceiverTypeEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid ReceiverType", value)
}

// NewReceiverTypeFromValue returns a pointer to a valid ReceiverType
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewReceiverTypeFromValue(v int32) (*ReceiverType, error) {
	ev := ReceiverType(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for ReceiverType: valid values are %v", v, AllowedReceiverTypeEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v ReceiverType) IsValid() bool {
	for _, existing := range AllowedReceiverTypeEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to ReceiverType value
func (v ReceiverType) Ptr() *ReceiverType {
	return &v
}

type NullableReceiverType struct {
	value *ReceiverType
	isSet bool
}

func (v NullableReceiverType) Get() *ReceiverType {
	return v.value
}

func (v *NullableReceiverType) Set(val *ReceiverType) {
	v.value = val
	v.isSet = true
}

func (v NullableReceiverType) IsSet() bool {
	return v.isSet
}

func (v *NullableReceiverType) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReceiverType(val *ReceiverType) *NullableReceiverType {
	return &NullableReceiverType{value: val, isSet: true}
}

func (v NullableReceiverType) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReceiverType) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

